unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  extctrls,

  uMap, uMunition, uNichtLebende, uPlusEinLeben, uReSpawn,
  uSchluessel,  uStart, uTeleporter, uTuer, uWaffe, uZiel, uDueg, uBewegtesHinderniss,
  uFigur, uGegner, uHeiltrank, uHinderniss, uLebende, uHandWaffe, StdCtrls, uschuss,
  MPlayer,mmsystem;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Timer_Menue: TTimer;
    Label2: TLabel;
    lblMB: TLabel;
    Label3: TLabel;
    lblLebenspunkte: TLabel;
    Label4: TLabel;
    lblAnzLeben: TLabel;
    Label5: TLabel;
    lblWaffen: TLabel;
    Label7: TLabel;
    lblAktuelleWaffe: TLabel;
    tmrMG: TTimer;
    tmrLaser: TTimer;
    tmrUnverwundbar: TTimer;
    label2000: TLabel;
    lblUnverwundbar: TLabel;
    Label6: TLabel;
    lblUebrige: TLabel;
    timer_run: TTimer;
    tmrGegner: TTimer;
    MediaPlayer1: TMediaPlayer;
    chMusik: TCheckBox;
    tmrMini: TTimer;
    procedure tmrMiniTimer(Sender: TObject);
    procedure chMusikClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer_MenueTimer(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure tmrLaserTimer(Sender: TObject);
    procedure tmrMGTimer(Sender: TObject);
    procedure tmrUnverwundbarTimer(Sender: TObject);
    procedure timer_runTimer(Sender: TObject);
    procedure tmrGegnerTimer(Sender: TObject);

  private
    { Private declarations }
  public
        procedure zeichnen;
        procedure main;
        procedure zeichnen_menue;
    { Public declarations }
  end;



var
  Form1: TForm1;
  puffer,A1,A2,A3,A4,B1,B2,B3,B4,C1,C2,C3,C4,gameover,gameover_n,sieg,sieg_n : TBitmap;  //Menubilder
  Image: TImage;
  menue: boolean;   //Menu luft
  zeit: real;       //Sprungberechnung nach vergangener Zeit
  blicke : Integer;  //Blickrichtung des Spielers
  LaufX : Integer;
  dX, dY, X_alt, Y_alt,zufall, schuesse : Integer; //Bewegungswerte
  restart, win : boolean;              //Keine Leben mehr --> Restart
  Level1 : TMap;                  //aktuelles Level
  aktuellemap,miller: string;            //Level das geladen werden soll
  Spieler : TFigur;               //Das lustige LCD
  NichtLebende : Array of TNichtLebende;    // Alle Hindernisse, Dgs, usw
  Gegner : Array of TGegner;                // Alle Gegner
  stehhind,steheauf,falllinks,fallrechts,steheaufhind:integer;   //Zur Berechnung von Kollisionen mit Hindernissen


implementation

{$R *.dfm}

//------------------------------------------------------------------------------
//---------------Zeichnen-------------------------------------------------------
//------------------------------------------------------------------------------

procedure TForm1.zeichnen_menue;
Var i,hg: Integer;
begin
      //Der Ausschnitt des Hintergrundes der gezeichnet werden soll
     hg := (Spieler.X + 500) DIV Level1.Width;

     // Voriges bzw. Aktuelles
     Windows.BitBlt(puffer.Canvas.Handle, 0, 0, Level1.Width, Level1.Height, Level1.Picture.Canvas.Handle, Spieler.X - (hg-1) * Level1.Width , 0, SRCCOPY);
     // Kommendes
     Windows.BitBlt(puffer.Canvas.Handle, 500 + (Level1.Width * hg - (Spieler.X + 500)), 0, Level1.Width, Level1.Height, Level1.Picture.Canvas.Handle, 0 , 0, SRCCOPY);

     // Alle Nicht-Lebende puffern
     For i := 0 to High(NichtLebende) Do Begin
       If (NichtLebende[i].X + NichtLebende[i].Width > (Spieler.X)) and (NichtLebende[i].X < (Spieler.X + 500)) and
          (NichtLebende[i].Y > 0) and (NichtLebende[i].Y - NichtLebende[i].Height < 500) then Begin
             Windows.StretchBlt(puffer.Canvas.Handle, NichtLebende[i].x - Spieler.X, Image.Height - NichtLebende[i].Y, NichtLebende[i].Width, NichtLebende[i].Height, NichtLebende[i].PictureInvert.Canvas.Handle, 0, 0, NichtLebende[i].PictureInvert.Width , NichtLebende[i].PictureInvert.Height, SRCAND);
             Windows.StretchBlt(puffer.Canvas.Handle, NichtLebende[i].x - Spieler.X, Image.Height - NichtLebende[i].Y, NichtLebende[i].Width, NichtLebende[i].Height, NichtLebende[i].Picture.Canvas.Handle, 0, 0,NichtLebende[i].Picture.Width ,NichtLebende[i].Picture.Height , SRCINVERT);
       end;
     End;

     //Den Spieler puffern
     Windows.StretchBlt(puffer.Canvas.Handle, 250, Image.Height - Spieler.Y, Spieler.Width, Spieler.Height, Spieler.PictureInvert.Canvas.Handle, 0, 0, Spieler.PictureInvert.Width, Spieler.PictureInvert.Height, SRCAND);
     Windows.StretchBlt(puffer.Canvas.Handle, 250, Image.Height - Spieler.Y, Spieler.Width, Spieler.Height, Spieler.Picture.Canvas.Handle, 0, 0, Spieler.Picture.Width, Spieler.Picture.Height , SRCINVERT);

     //Wenn Spieler Waffe besitzt --> anzeigen
     if Spieler.AktuelleWaffe <> NIL Then Begin
        Windows.StretchBlt(puffer.Canvas.Handle, 250 + 5, Image.Height - Spieler.Y + 30, Spieler.AktuelleWaffe.Width, Spieler.AktuelleWaffe.Height, Spieler.AktuelleWaffe.PictureInvert.Canvas.Handle, 0, 0, Spieler.AktuelleWaffe.PictureInvert.Width, Spieler.AktuelleWaffe.PictureInvert.Height, SRCAND);
        Windows.StretchBlt(puffer.Canvas.Handle, 250 + 5, Image.Height - Spieler.Y + 30, Spieler.AktuelleWaffe.Width, Spieler.AktuelleWaffe.Height, Spieler.AktuelleWaffe.Picture.Canvas.Handle, 0, 0, Spieler.AktuelleWaffe.Picture.Width, Spieler.AktuelleWaffe.Picture.Height , SRCINVERT);
     End;

     //Menuschrift
     Windows.BitBlt(puffer.Canvas.Handle, 150, 150, a4.Width, a4.Height, a2.Canvas.Handle, 0, 0, SRCAND);
     Windows.BitBlt(puffer.Canvas.Handle, 150, 150, a4.Width, a4.Height, a4.Canvas.Handle, 0, 0, SRCINVERT);
     Windows.BitBlt(puffer.Canvas.Handle, 150, 250, b4.Width, b4.Height, b2.Canvas.Handle, 0, 0, SRCAND);
     Windows.BitBlt(puffer.Canvas.Handle, 150, 250, b4.Width, b4.Height, b4.Canvas.Handle, 0, 0, SRCINVERT);
     Windows.BitBlt(puffer.Canvas.Handle, 150, 200, c4.Width, c4.Height, c2.Canvas.Handle, 0, 0, SRCAND);
     Windows.BitBlt(puffer.Canvas.Handle, 150, 200, c4.Width, c4.Height, c4.Canvas.Handle, 0, 0, SRCINVERT);

     //Wenn Menu durch Tod aufgerufen wurde
    if spieler.AnzLeben <=0 then
    begin
     //zustzliche Schrift 'GAME OVER'
     Windows.BitBlt(puffer.Canvas.Handle, 150, 10, gameover.Width, gameover.Height, gameover_n.Canvas.Handle, 0, 0, SRCAND);
     Windows.BitBlt(puffer.Canvas.Handle, 150, 10, gameover.Width, gameover.Height, gameover.Canvas.Handle, 0, 0, SRCINVERT);
     SetLength(NichtLebende, 0);
     SetLength(Gegner, 0);      //RESET der Spieles
     restart:=true;
    end;

    if win=true then
    begin
     //zustzliche Schrift 'Gewonnen'

     sleep(300);
     Windows.BitBlt(puffer.Canvas.Handle, 150, 10, sieg.Width, sieg.Height, sieg_n.Canvas.Handle, 0, 0, SRCAND);
     Windows.BitBlt(puffer.Canvas.Handle, 150, 10, sieg.Width, sieg.Height, sieg.Canvas.Handle, 0, 0, SRCINVERT);
     SetLength(NichtLebende, 0);
     SetLength(Gegner, 0);      //RESET der Spieles
     restart:=true;

 //sndplaysound(ExtractFilePath(ParamStr(0))+'\zoid1.wav',SND_aSync);

    end;


     // Puffer sichtbar machen
     Windows.BitBlt(Image.Canvas.Handle, 0, 0, Image.Width , Image.Height , puffer.Canvas.Handle, 0, 0, SRCCOPY);
     Image.Repaint;
end;



procedure TForm1.zeichnen; //Analog zum Menu
Var i,hg : Integer;
begin
     //Hintergrund
     hg := (Spieler.X + 500) DIV Level1.Width;

     // Voriges bzw. Aktuelles
     Windows.BitBlt(puffer.Canvas.Handle, 0, 0, Level1.Width, Level1.Height, Level1.Picture.Canvas.Handle, Spieler.X - (hg-1) * Level1.Width , 0, SRCCOPY);

     // Kommendes
     Windows.BitBlt(puffer.Canvas.Handle, 500 + (Level1.Width * hg - (Spieler.X + 500)), 0, Level1.Width, Level1.Height, Level1.Picture.Canvas.Handle, 0 , 0, SRCCOPY);

     // Nicht-Lebende anzeigen
     For i := 0 to High(NichtLebende) Do Begin
       If (NichtLebende[i].X + NichtLebende[i].Width > (Spieler.X)) and (NichtLebende[i].X < (Spieler.X + 500)) and
          (NichtLebende[i].Y > 0) and (NichtLebende[i].Y - NichtLebende[i].Height < 500) then Begin
             Windows.StretchBlt(puffer.Canvas.Handle, NichtLebende[i].x - Spieler.X, Image.Height - NichtLebende[i].Y, NichtLebende[i].Width, NichtLebende[i].Height, NichtLebende[i].PictureInvert.Canvas.Handle, 0, 0, NichtLebende[i].PictureInvert.Width , NichtLebende[i].PictureInvert.Height, SRCAND);
             Windows.StretchBlt(puffer.Canvas.Handle, NichtLebende[i].x - Spieler.X, Image.Height - NichtLebende[i].Y, NichtLebende[i].Width, NichtLebende[i].Height, NichtLebende[i].Picture.Canvas.Handle, 0, 0,NichtLebende[i].Picture.Width ,NichtLebende[i].Picture.Height , SRCINVERT);
       end;
     End;

     //Gegner zeichnen
    For i := 0 to High(Gegner) Do Begin
       If (Gegner[i].X + Gegner[i].Width > (Spieler.X)) and (Gegner[i].X < (spieler.X + 500)) and
          (Gegner[i].Y > 0) and (Gegner[i].Y - Gegner[i].Height < 500) then Begin
             Windows.StretchBlt(puffer.Canvas.Handle, Gegner[i].x - Spieler.X, Image.Height - Gegner[i].Y, Gegner[i].Width, Gegner[i].Height, Gegner[i].PictureInvert.Canvas.Handle, 0, 0, Gegner[i].PictureInvert.Width , Gegner[i].PictureInvert.Height, SRCAND);
             Windows.StretchBlt(puffer.Canvas.Handle, Gegner[i].x - Spieler.X, Image.Height - Gegner[i].Y, Gegner[i].Width, Gegner[i].Height, Gegner[i].Picture.Canvas.Handle, 0, 0,Gegner[i].Picture.Width ,Gegner[i].Picture.Height , SRCINVERT);
       end;
     End;

     //Figur
     Windows.StretchBlt(puffer.Canvas.Handle, 250, Image.Height - Spieler.Y, Spieler.Width, Spieler.Height, Spieler.PictureInvert.Canvas.Handle, 0, 0, Spieler.PictureInvert.Width, Spieler.PictureInvert.Height, SRCAND);
     Windows.StretchBlt(puffer.Canvas.Handle, 250, Image.Height - Spieler.Y, Spieler.Width, Spieler.Height, Spieler.Picture.Canvas.Handle, 0, 0, Spieler.Picture.Width, Spieler.Picture.Height , SRCINVERT);

     //Waffe anzeigen
     if Spieler.AktuelleWaffe <> NIL Then Begin
        if spieler.richtung=2 then begin
        Windows.StretchBlt(puffer.Canvas.Handle, 250 + 5, Image.Height - Spieler.Y + 30, Spieler.AktuelleWaffe.Width, Spieler.AktuelleWaffe.Height, Spieler.AktuelleWaffe.PictureInvert.Canvas.Handle, 0, 0, Spieler.AktuelleWaffe.PictureInvert.Width, Spieler.AktuelleWaffe.PictureInvert.Height, SRCAND);
        Windows.StretchBlt(puffer.Canvas.Handle, 250 + 5, Image.Height - Spieler.Y + 30, Spieler.AktuelleWaffe.Width, Spieler.AktuelleWaffe.Height, Spieler.AktuelleWaffe.Picture.Canvas.Handle, 0, 0, Spieler.AktuelleWaffe.Picture.Width, Spieler.AktuelleWaffe.Picture.Height , SRCINVERT);
        end
        else begin
        Windows.StretchBlt(puffer.Canvas.Handle, 250 - 45, Image.Height - Spieler.Y + 30, Spieler.AktuelleWaffe.Width, Spieler.AktuelleWaffe.Height, Spieler.AktuelleWaffe.PictureInvert.Canvas.Handle, 0, 0, Spieler.AktuelleWaffe.PictureInvert.Width, Spieler.AktuelleWaffe.PictureInvert.Height, SRCAND);
        Windows.StretchBlt(puffer.Canvas.Handle, 250 - 45, Image.Height - Spieler.Y + 30, Spieler.AktuelleWaffe.Width, Spieler.AktuelleWaffe.Height, Spieler.AktuelleWaffe.Picture.Canvas.Handle, 0, 0, Spieler.AktuelleWaffe.Picture.Width, Spieler.AktuelleWaffe.Picture.Height , SRCINVERT);
        end;

     End;

     // Puffer sichtbar machen
     Windows.BitBlt(Image.Canvas.Handle, 0, 0, Image.Width , Image.Height , puffer.Canvas.Handle, 0, 0, SRCCOPY);
     Image.Repaint;
end;

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

procedure TForm1.main;   //HAUPTPROZEDUR
Var i,a,b,c, ind : Integer;
begin

   // Spielerdaten anzeigen
   lblMB.Caption := IntToStr(Spieler.MBVorrat);
   lblLebenspunkte.Caption := IntToStr(Spieler.Lebenspunkte);
   lblAnzLeben.Caption := IntToStr(Spieler.AnzLeben);
   lblWaffen.Caption := '';

   For i := 0 to High(Spieler.Waffe) Do Begin
       lblWaffen.Caption := inttostr(schuesse);
   End;

   If Spieler.AktuelleWaffe <> NIL Then  //ID der aktuellen Waffe
   Begin
        lblAktuelleWaffe.Caption := Spieler.AktuelleWaffe.Typ;
        lblUebrige.Caption := IntToStr(Spieler.AktuelleWaffe.UebrigeSchuesse);
   End;

   If Spieler.Unverwundbar = True then  //wenn kurz zuvor Lebenspunkt abgezogen
      lblunverwundbar.Caption := 'True'
   Else
       lblunverwundbar.Caption := 'False';

   // Bewegte Sachen weitersetzen
   For i := 0 to High(NichtLebende) Do Begin
       If NichtLebende[i] Is TSchuss Then // Schsse weitersetzen
       Begin
            NichtLebende[i].X := NichtLebende[i].X + Trunc((NichtLebende[i] as TSchuss).vx);

             //schauen ob schuss schon 500 px geflogen ist
            if (NichtLebende[i].X > (NichtLebende[i] as Tschuss).startX + 500) or (NichtLebende[i].X < (NichtLebende[i] as Tschuss).startX - 500) then
            begin
             dec(schuesse);
             NichtLebende[i].Free;           // Objekt dann lschen
                  For a := i to High(NichtLebende) - 1 Do Begin  // Alle anderen Objekte im Array nachrcken
                       NichtLebende[a] := NichtLebende[a+1];
                       If NichtLebende[a] is THinderniss then
                          (NichtLebende[a] as THinderniss).ID := a;
                       If NichtLebende[a] is TBewegtesHinderniss then
                          (NichtLebende[a] as TBewegtesHinderniss).ID := a;
                  End;
                  SetLength(NichtLebende,High(NichtLebende));
            end;
       End Else if NichtLebende[i] is TBewegtesHinderniss Then Begin //  bewegte Hindernisse weitersetzen
            NichtLebende[i].X := NichtLebende[i].X + (NichtLebende[i] as TBewegtesHinderniss).vx;
            NichtLebende[i].Y := NichtLebende[i].Y + (NichtLebende[i] as TBewegtesHinderniss).vy;

            //bewegtes HN wird weitergesetzt
            If NichtLebende[i].X < (NichtLebende[i] as TBewegtesHinderniss).Left then (NichtLebende[i] as TBewegtesHinderniss).vx := -1 * (NichtLebende[i] as TBewegtesHinderniss).vx;
            If NichtLebende[i].X > (NichtLebende[i] as TBewegtesHinderniss).Right then (NichtLebende[i] as TBewegtesHinderniss).vx := - 1 * (NichtLebende[i] as TBewegtesHinderniss).vx;
            If NichtLebende[i].Y < (NichtLebende[i] as TBewegtesHinderniss).Bottom Then (NichtLebende[i] as TBewegtesHinderniss).vy := -1 * (NichtLebende[i] as TBewegtesHinderniss).vy;
            If NichtLebende[i].Y > (NichtLebende[i] as TBewegtesHinderniss).Top Then (NichtLebende[i] as TBewegtesHinderniss).vy := -1 * (NichtLebende[i] as TBewegtesHinderniss).vy;

            If (steheaufhind = i)  then    //Wenn Spieler af gerade getesteten Hindernis steht
            begin
                 falllinks:=NichtLebende[i].X;                          //Bewegtes Hinderniss ndert dauernd
                 fallrechts:=NichtLebende[i].X+NichtLebende[i].width;   //seine Runterfallgrenzen
                 steheauf:=nichtlebende[i].Y+3;     //Man fhrt auf Fahrstuhl mit, und schwebt quasi darber, Ebene auf der man steht wird angepasst
                 spieler.y:=spieler.y + (NichtLebende[i] as TBewegtesHinderniss).vy;  //Spieler bewegt sich mit dem Hindernis mit
                 spieler.X:=spieler.x + (NichtLebende[i] as TBewegtesHinderniss).vx;
            end;

  End;
   End;

   LaufX := -1;

  i := 0;

  //Alle Gegner fhren ihre "KI" aus
   while i <= High(gegner) Do
    begin
    gegner[i].ki;
    inc(I);
    end;

    i:=0;
    
   //prfen ob Spieler den Gegner berhrt
   while i <= High(gegner) Do
     Begin
     If (gegner[i].X + gegner[i].Width > (Spieler.X + 250)) and (gegner[i].X < (Spieler.X + 250) + Spieler.Width) and
        (gegner[i].Y > Spieler.Y - Spieler.Height) and (gegner[i].Y - gegner[i].Height < Spieler.Y) then
        Begin
        gegner[i].event(Spieler); // Event auslsen
        End ;
    i := i + 1; // nchstes Objekt
    End;

    // alle Objekte mit Spieler prfen
   i:=0;
   while i <= High(NichtLebende) Do begin
     If (NichtLebende[i].X + NichtLebende[i].Width > (Spieler.X + 250)) and (NichtLebende[i].X < (Spieler.X + 250) + Spieler.Width) and
        (NichtLebende[i].Y > Spieler.Y - Spieler.Height) and (NichtLebende[i].Y - NichtLebende[i].Height < Spieler.Y) then
        Begin

             If not (NichtLebende[i] is TSchuss) Then Begin // wenn kein Schuss
                  NichtLebende[i].event(Spieler); // Event auslsen
             End Else Begin // wenn Schuss von Gegner
                  dec(schuesse);
                  NichtLebende[i].Event(Spieler); // Event fr Schuss von Gegner auslsen
             end;
         //    If (NichtLebende[i] is TZiel) then
         //     nichtlebende[i].Event(spieler);

             //Wenn das Hindernis einsammelbar ist
             If (Not (NichtLebende[i] is TTeleporter)) and (not (NichtLebende[i] is TRespawn)) and (not (NichtLebende[i] is THinderniss)) and (not (NichtLebende[i] is Tstart))Then // wenn kein Teleporter
             Begin
                  NichtLebende[i].Free;           // Objekt dann lschen
                  For a := i to High(NichtLebende) - 1 Do Begin  // Alle anderen Objekte im Array nachrcken
                       NichtLebende[a] := NichtLebende[a+1];
                       If NichtLebende[a] is THinderniss then
                          (NichtLebende[a] as THinderniss).ID := a;
                       If NichtLebende[a] is TBewegtesHinderniss then
                          (NichtLebende[a] as TBewegtesHinderniss).ID := a;
                  End;
                  SetLength(NichtLebende,High(NichtLebende));  // letztes lschen
             End;
        End;

    i := i + 1; // nchstes Objekt
    End;

    // alle gegner mit schssen prfen
   i:=0;
   while i <= High(NichtLebende) Do Begin
     If NichtLebende[i] is TSchuss then begin
     b := 0;
     while (b <= High(gegner)) and (schuesse<>0) Do Begin
     If (NichtLebende[i].X + NichtLebende[i].Width > (gegner[b].X)) and (NichtLebende[i].X < (gegner[b].X ) + gegner[b].Width) and
        (NichtLebende[i].Y > gegner[b].Y - gegner[b].Height) and (NichtLebende[i].Y - NichtLebende[i].Height < gegner[b].Y) then
        Begin
             NichtLebende[i].EventGegner(Gegner[b]); // Event fr Schuss von Gegner auslsen
                dec(schuesse);
             If Gegner[b].Lebenspunkte <= 0 then Begin
                zufall:=1+random(7); //von 1 bis 7
                sndplaysound(pchar(ExtractFilePath(ParamStr(0))+'\sounds\gegnertod'+inttostr(zufall)+'.wav'),SND_aSync);

                Gegner[b].Free;
                For a := b to High(Gegner) - 1 Do Begin
                  gegner[a] := gegner[a+1];
                End;
                SetLength(gegner,High(gegner));  // letztes lschen
             End;
             Begin
                  NichtLebende[i].Free;           // Objekt dann lschen
                  For a := i to High(NichtLebende) - 1 Do Begin  // Alle anderen Objekte im Array nachrcken
                       NichtLebende[a] := NichtLebende[a+1];
                       If NichtLebende[a] is THinderniss then
                          (NichtLebende[a] as THinderniss).ID := a;
                       If NichtLebende[a] is TBewegtesHinderniss then
                          (NichtLebende[a] as TBewegtesHinderniss).ID := a;
                  End;
                  SetLength(NichtLebende,High(NichtLebende));  // letztes lschen
             End;
        End;

     b := b + 1;
    end;
    end;
    i := i + 1; // nchstes Objekt
    End;

     // Sprung
    Begin
      if Spieler.y > laufx + Spieler.Height then // wenn nicht auf Boden
         zeichnen  // weiter springen und zeichnen
      else begin  // auf Boden setzen
        Spieler.y := laufx + spieler.Height;
        zeichnen;
        zeit := 0;
        Spieler.vy := 0;
      end;
    End;
    //Flugbahn berechenen
    Spieler.y := trunc(Spieler.y + (((Spieler.vy * zeit) - (13 / 2) * (zeit * zeit)))); //Y neu berechnen

    //Wenn von einem bewegten Hindernis runtergefallen
    IF (fallrechts<spieler.x+250) or (falllinks>spieler.x+250+spieler.width) then
    begin
    steheauf:=0;       //Gerade auf der Spieler steht reseten
    steheaufhind:=0;   //Hindernis auf dem Spieler steht reseten
    end;

    if spieler.y<steheauf+spieler.Height then // wenn er unter die Gerade "steheauf" fallen wrde
    begin
     spieler.Y:= steheauf+spieler.Height;
     zeit := 0;                            // verhindere dass es fllt
     Spieler.vy := 0;
    end;

    dx := Spieler.X - x_alt;         //Im letzten Tick zurckgelegte Strecken berechnen
    dy := Spieler.Y - y_alt;
 end;


procedure TForm1.FormCreate(Sender: TObject);
var s: TStrings; toetlich_b: boolean; i, j, z, c: integer; HG,temp,pLeft, pRight, pBottom, pTop, pvx, pvy,ID, Groesse, X, Y, Width, divWidth, Height, divHeight, toetlich, Textur, Typen: String;
begin
  randomize;
zufall:=random(6)+1;
  Mediaplayer1.filename:=ExtractFilePath(ParamStr(0))+'\sounds\HG'+inttostr(zufall)+'.mid';
  Mediaplayer1.Open;
  If chmusik.Checked = true then
  Mediaplayer1.Play;
  zufall:=random(8)+1;
  sndplaysound(pchar(ExtractFilePath(ParamStr(0))+'\sounds\start'+inttostr(zufall)+'.wav'),SND_aSync);


  win:=false;
  //Werte auf 0 stellen
  schuesse:=0;
  steheauf:=39;
  restart:=false;
  tmrunverwundbar.enabled:=false;
  tmrunverwundbar.enabled:=true;
  falllinks:=0;
  fallrechts:=10000;
  if aktuellemap = '' then aktuellemap := 'Map101.txt'; //mapauswahl

  //===AUSLESEN DER MAP-TXT==//
  s := TStringList.Create;
  s.loadfromfile(ExtractFilePath(ParamStr(0))+aktuellemap);
  hg := s[StrToInt(s.Strings[0])+1];
  Level1 := TMap.Create(hg,'Level1',0,0);

  z:=-1;  //Gegnerindex
  for i := 1 to (StrToInt(s.Strings[0])) do
  begin

    j := 1;
    temp := s.Strings[i];
    Groesse := '';
    X := '';
    Y := '';
    Width := '';
    divWidth := '';
    Height := '';
    divHeight := '';
    toetlich := '';
    Textur := '';
    Typen := '';
    ID:='';
    pLeft:='';
    pRight:='';
    pBottom:='';
    pTop:='';
    pvx:='';
    pvy:='';

    while temp[j] <> ',' do
    begin
      Typen := Typen + temp[j];
      inc(j);
    end;
    inc(j);



    while temp[j] <> ',' do
    begin
      x := x + temp[j];
      inc(j);
    end;
    inc(j);

    while temp[j] <> ',' do
    begin
      y := y + temp[j];
      inc(j);
    end;
    inc(j);

    while temp[j] <> ',' do
    begin
      Width := Width + temp[j];
      inc(j);
    end;
    inc(j);

    while temp[j] <> ',' do
    begin
      divWidth := divWidth + temp[j];
      inc(j);
    end;
    inc(j);

    while temp[j] <> ',' do
    begin
      Height := Height + temp[j];
      inc(j);
    end;
    inc(j);

    while temp[j] <> ',' do
    begin
      divHeight := divHeight + temp[j];
      inc(j);
    end;
    inc(j);

    while temp[j] <> ',' do
    begin
      Groesse := Groesse + temp[j];
      inc(j);
    end;
    inc(j);

    while temp[j] <> ',' do
    begin
      toetlich := toetlich + temp[j];
      inc(j);
    end;

    if  (toetlich = 'true') then
    toetlich_b := true
    else toetlich_b := false;
    inc(j);

    while temp[j] <> ',' do
    begin
      Textur := Textur + temp[j];
      inc(j);
    end;
     inc(j);

    if (typen='2') or (typen='7') or (typen='14') or (typen='17')then   //WENN EIN HINDERNIS oder TR--> ID rauslesen
    begin
     while temp[j] <> ',' do
     begin
      ID := ID + temp[j];
      inc(j);
     end;
     inc(j);
    end;


   if (typen='2') then     // WENN ein BEWEGTES HINDERNISS -->
   begin
    while temp[j] <> ',' do
     begin
      pLeft := pLeft + temp[j];
      inc(j);
     end;
     inc(j);

    while temp[j] <> ',' do
    begin
      pRight := pRight + temp[j];
      inc(j);
    end;
    inc(j);

    while temp[j] <> ',' do
    begin
      pBottom := pBottom + temp[j];
      inc(j);
    end;
    inc(j);

    while temp[j] <> ',' do
    begin
      pTop := pTop + temp[j];
      inc(j);
    end;
    inc(j);

    while temp[j] <> ',' do
    begin
      pvx := pvx + temp[j];
      inc(j);
    end;
    inc(j);

    while temp[j] <> ',' do
    begin
      pvy := pvy + temp[j];
      inc(j);
    end;
    inc(J);
   end;

   if (typen='16') then     // WENN ein Gegener -->
   begin
   while temp[j] <> ',' do
    begin
      pvx:=pvx+temp[j];
      inc(j);
    end;
    inc(j);

    while temp[j] <> ',' do
    begin
      pvy:=pvy+temp[j];
      inc(j);
    end;
   end;


//-Speichern-//
//wenn ein Gegner/nichtlebend  --> array hochsetzen
    If (typen='16') then
    begin
      inc(z);
      setlength(gegner,high(gegner)+2);
    end
    else
      SetLength(NichtLebende, high(nichtlebende)+2);

    // wenn ein nichtlebend
    case StrToInt(Typen) of
      1 : NichtLebende[i-1] :=
        TStart.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),Textur);
      2 : NichtLebende[i-1] :=
        TBewegtesHinderniss.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),strtoint(ID),strtoint(pleft),strtoint(pright),strtoint(pbottom),strtoint(ptop),strtoint(pvx),strtoint(pvy),toetlich_b,Textur);
      3 : NichtLebende[i-1] :=
        TDueg.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),StrToInt(Groesse),Textur);
      4 : NichtLebende[i-1] :=
        THandWaffe.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),20,100,1,300,'mg','mg');
      5 : NichtLebende[i-1] :=
        THandWaffe.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),10, 50,2,800,'laser','laser');
      6 : NichtLebende[i-1] :=
        THeiltrank.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),Textur);
      7 : NichtLebende[i-1] :=
        THinderniss.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),strtoint(ID),toetlich_b,Textur);
      8 : NichtLebende[i-1] :=
        TMunition.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),StrToInt(Groesse),'ammo',Textur);
      9 : NichtLebende[i-1] :=
        TPlusEinLeben.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),Textur);
      10 : NichtLebende[i-1] :=
        TRespawn.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),Textur);
      11 : NichtLebende[i-1] :=
        TSchluessel.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),StrToInt(Groesse),Textur);
      12 : begin
          For c := 0 to high(NichtLebende)-1 Do Begin
            if (NichtLebende[c] is TTeleporter) and ((NichtLebende[c] as TTeleporter).id = StrToInt(Groesse)) then
            begin
        NichtLebende[i-1] := TTeleporter.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),Textur,NichtLebende[c],StrToInt(Groesse));
            end;
          end;
           end;
      13 : NichtLebende[i-1] :=
        TTeleporter.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),Textur,nil,StrToInt(Groesse));
      14 : NichtLebende[i-1] :=
        TTuer.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),strtoint(ID),5,Textur,'d');
      15 : NichtLebende[i-1] :=
        TZiel.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),Textur);
      16 : Gegner[z] :=
        TGegner.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),strtoint(pvx),strtoint(pvy),Textur);
      17 : NichtLebende[i-1] :=
        Ttuer.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),strtoint(ID),strtoint(groesse),Textur,Textur+'_o');   
      18 : NichtLebende[i-1] :=
        THandWaffe.create(StrToInt(X),StrToInt(Y),StrToInt(Width) DIV StrToInt(divWidth),StrToInt(Height) DIV StrToInt(divHeight),50,200,1,100,'mini','mini');
    end;
    end;

    //Spieler am Startpunkt erstellen
   Spieler := TFigur.Create(NichtLebende[0].X-250,NichtLebende[0].y,40,80,0); // Spieler erstellen

  // Picturehandels createn zum Anzeigen (des Menus)
  Image := Image1;

  puffer := TBitmap.Create;
  puffer.Width := Level1.Width;
  puffer.Height := Level1.Height;

  A1 := TBitmap.Create;
  A1.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\info_b.bmp');

  A2 := TBitmap.Create;
  A2.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\info_n.bmp');

  A3 := TBitmap.Create;
  A3.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\info_r.bmp');

  A4 := TBitmap.Create;
  a4 := a1;

  B1 := TBitmap.Create;
  B1.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\exit_b.bmp');

  B2 := TBitmap.Create;
  B2.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\exit_n.bmp');

  B3 := TBitmap.Create;
  B3.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\exit_r.bmp');

  B4 := TBitmap.Create;
  b4 := b1;

  C1 := TBitmap.Create;
  C1.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\map_b.bmp');

  C2 := TBitmap.Create;
  C2.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\map_n.bmp');

  C3 := TBitmap.Create;
  C3.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\map_r.bmp');

  C4 := TBitmap.Create;
  C4 := C1;

  gameover := TBitmap.Create;
  gameover.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\gameover.bmp');

  gameover_n := TBitmap.Create;
  gameover_n.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\gameover_n.bmp');

  sieg := TBitmap.Create;
  sieg.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\win.bmp');

  sieg_n := TBitmap.Create;
  sieg_n.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\win_n.bmp');


  zeit:=1;
  menue := false;
  form1.Timer_Menue.Enabled := false;    //timer aktivieren
  form1.timer_run.enabled:= true;
end;


procedure TForm1.Timer_MenueTimer(Sender: TObject);  //MENU luft
begin
  zeichnen_menue;
  if (windows.GetAsyncKeyState(27) <> 0) then
  begin
  if restart=true then
   FormCreate(Form1);

    menue := false;
    sleep(250);
    form1.Timer_Menue.Enabled := false;
    form1.Timer_Run.Enabled := true;

  end;

end;

//Mausbewegung im Menu
procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if (menue) and ((x > 150) and (x < 350) and (y > 150) and (y < 200)) then
    a4 := a3 else a4 := a1;
  if (menue) and ((x > 150) and (x < 350) and (y > 250) and (y < 300)) then
    b4 := b3 else b4 := b1;
  if (menue) and ((x > 150) and (x < 350) and (y > 200) and (y < 250)) then
    c4 := c3 else c4 := c1;
end;

//Auswahl im Menu
procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i,p: string;
j:integer;
begin
  if (menue) and ((x > 150) and (x < 350) and (y > 150) and (y < 200)) then
    begin showmessage('Pei Wi Mi + Zoidy');
    showmessage('Special Thanks to Excalibur und Olli for the MAPS');
    showmessage('Schon den Lizensvertrag gelesen???');
    showmessage('Wirklich?????');
    showmessage('for Updates visit dueg.willkons.de');
    showmessage('fr neue Maps auch!');
    showmessage('und ansonsten natrlich auch!');
    i := Inputbox('Zahl','Gib mal ne Zahl ein','20');
    p := Inputbox('Zahl2','Multipliziere diese Zahl mit 100=',inttostr(strtoint(i)*100));

    showmessage('Du wirst jetz in eine For-Schleife geleitet...');

    for j:=1 to strtoint(i) do
     begin
     showmessage(Inttostr(j)+' von '+i+': Freuste dich?? Ehre den Zoidberg und den DG!');
     sleep(strtoint(p));
     end;
    for j:=strtoint(i)-1 downto 1 do
     begin
     showmessage(Inttostr(j)+' von '+i+': und alles wieder rckwrts?? Ehre den Zoidberg und den DG!');
     sleep(strtoint(p));
     end;
    end;
  if (menue) and ((x > 150) and (x < 350) and (y > 250) and (y < 300)) then
    close;
  if (menue) and ((x > 150) and (x < 350) and (y > 200) and (y < 250)) then
  begin
    aktuellemap := Inputbox('Case Map','Gib den Namen der Map ein, die du spielen mchtest:','Map1.txt');
    SetLength(NichtLebende, 0);
    SetLength(Gegner, 0);
    FormCreate(Sender);
  end;
end;



//ob laserwaffe schon wieder schieen darf
procedure TForm1.tmrLaserTimer(Sender: TObject);
Var i : Integer;
begin
     For i := 0 to High(Spieler.Waffe) Do Begin
         If Spieler.Waffe[i].Typ = 'laser' then
            Spieler.Waffe[i].CanShot := True;
     End;
     tmrLaser.Enabled := False;
end;

//ob AK schon wieder schieen darf
procedure TForm1.tmrMGTimer(Sender: TObject);
Var i : Integer;
begin
     For i := 0 to High(Spieler.Waffe) Do Begin
         If Spieler.Waffe[i].Typ = 'mg' then
            Spieler.Waffe[i].CanShot := True;
     End;
     tmrMG.Enabled := False;
end;

procedure TForm1.tmrMiniTimer(Sender: TObject);
Var i : Integer;
begin
     For i := 0 to High(Spieler.Waffe) Do Begin
         If Spieler.Waffe[i].Typ = 'mini' then
            Spieler.Waffe[i].CanShot := True;
     End;
     tmrMini.Enabled := False;
end;

//ob der Spieler noch unverwundbar ist
procedure TForm1.tmrUnverwundbarTimer(Sender: TObject);
begin
     Spieler.Unverwundbar := False;
end;

procedure TForm1.timer_runTimer(Sender: TObject);
var i:integer;
begin
begin

// Sprung
  if (windows.GetAsyncKeyState(32) <> 0) or (windows.GetAsyncKeyState(84) <> 0) or (windows.GetAsyncKeyState(38) <> 0) then
  begin
    if (Spieler.vy < 1) and (Spieler.vy > -1) then // wenn nicht in Sprung
    begin // neuer Sprung
      zeit := 1; // Zeit fr neuen Sprung
      Spieler.y := Spieler.y + 1; // damit nicht mehr Kollision mit Hinderniss
      if (dy=0) or (steheaufhind<>-1) then    //Spieler darf nur springen wenn er ruhig dasteht oder auf Hindernis steht
      Spieler.vy := 17;
    end;
  end;

// Rechts
  if (windows.GetAsyncKeyState(39) <> 0) then
   begin
    if (Spieler.vy > 1) or (Spieler.vy < -1) then // wenn in Sprung
       Spieler.x := Spieler.x + 10  // evtl. mehr nach vorne --> ABER: Bunny-Hop
    else
       Spieler.x := Spieler.x + 10;
         spieler.change(2);    //spieler schaut nach rechts
   end;

// Links
  if (windows.GetAsyncKeyState(37) <> 0) then
  begin

   if (Spieler.vy > 1) or (Spieler.vy < -1) then  // wenn in Sprung
    Spieler.x := Spieler.x - 10  // evtl. mehr nach hinten --> ABER: Bunny-Hop
    else
    Spieler.x := Spieler.x - 10;

    spieler.change(1);   //spieler schaut nach links

    end;

// ESC
  if (windows.GetAsyncKeyState(27) <> 0) then
  begin
      menue := true;
      form1.Timer_Menue.Enabled := true; // menue anzeigen
      sleep(250);
      form1.Timer_Run.Enabled := false;  // spiel anhalten
  end;

// 1 --> Keine Waffe
  if (windows.GetAsyncKeyState(49) <> 0) then
  begin
       Spieler.AktuelleWaffe := NIL;
  end;

// 2 --> MG
  if (windows.GetAsyncKeyState(50) <> 0) then
  begin
       For i := 0 to High(Spieler.Waffe) Do Begin
           If Spieler.Waffe[i].Typ = 'mg' Then
           begin
             Spieler.AktuelleWaffe := Spieler.Waffe[i];
             spieler.aktuellewaffe.change(spieler.richtung);
           end;
       End;
  end;

// 3 --> Laser
  if (windows.GetAsyncKeyState(51) <> 0) then
  begin
       For i := 0 to High(Spieler.Waffe) Do Begin
           If Spieler.Waffe[i].Typ = 'laser' Then
           begin
             Spieler.AktuelleWaffe := Spieler.Waffe[i];
             spieler.aktuellewaffe.change(spieler.richtung);
           end;
       End;
  end;
  
// 4 --> Minimi
  if (windows.GetAsyncKeyState(52) <> 0) then
  begin
       For i := 0 to High(Spieler.Waffe) Do Begin
           If Spieler.Waffe[i].Typ = 'mini' Then
           begin
             Spieler.AktuelleWaffe := Spieler.Waffe[i];
             spieler.aktuellewaffe.change(spieler.richtung);
           end;
       End;
  end;

// STRG-Taste zum Schieen
  If (windows.GetAsyncKeyState(17) <> 0) Then
  Begin
       If Spieler.AktuelleWaffe <> NIL Then Begin // wenn Spieler Waffe in Hand
          If Spieler.AktuelleWaffe.CanShot = True then Begin // wenn man schieen kann
             If Spieler.AktuelleWaffe.UebrigeSchuesse > 0 then Begin // wenn noch Schsse da
                SetLength(NichtLebende, High(NichtLebende) + 2); // Schuss als Nichtlebendes ins Array
                // Schuss createn, je nach Waffe
                If Spieler.AktuelleWaffe.Typ = 'laser' then
                   Begin
                   inc(schuesse);
                      if spieler.richtung=2 then
                        NichtLebende[High(NichtLebende)] := TSchuss.create(Spieler.X + 250 + 30 ,Spieler.Y - 35,56,6,Spieler.AktuelleWaffe.Schaden ,15,'strahl')
                        else
                        NichtLebende[High(NichtLebende)] := TSchuss.create(Spieler.X + 250 - 70 ,Spieler.Y - 35,56,6,Spieler.AktuelleWaffe.Schaden ,-15,'strahl');

                        tmrLaser.Interval := Spieler.AktuelleWaffe.Schussfrequenz; //Waffe darf bestimmte zeit danach nicht schieen
                        tmrLaser.Enabled := True;
                   End;
                If Spieler.AktuelleWaffe.Typ = 'mg' then
                  Begin
                  inc(schuesse);
                   if spieler.richtung=2 then
                       NichtLebende[High(NichtLebende)] := TSchuss.create(Spieler.X + 250 + 40 ,Spieler.Y - 33,56,6,Spieler.AktuelleWaffe.Schaden,15,'schuss')
                    else
                      NichtLebende[High(NichtLebende)] := TSchuss.create(Spieler.X + 250 - 70 ,Spieler.Y - 33,56,6,Spieler.AktuelleWaffe.Schaden,-15,'schuss');

                       tmrMG.Interval := Spieler.AktuelleWaffe.Schussfrequenz;
                       tmrMG.Enabled := True;
                  End;               
                If Spieler.AktuelleWaffe.Typ = 'mini' then
                  Begin
                  inc(schuesse);
                   if spieler.richtung=2 then
                       NichtLebende[High(NichtLebende)] := TSchuss.create(Spieler.X + 250 + 40 ,Spieler.Y - 40,56,6,Spieler.AktuelleWaffe.Schaden,15,'schuss')
                    else
                      NichtLebende[High(NichtLebende)] := TSchuss.create(Spieler.X + 250 - 70 ,Spieler.Y - 40,56,6,Spieler.AktuelleWaffe.Schaden,-15,'schuss');

                       tmrMini.Interval := Spieler.AktuelleWaffe.Schussfrequenz;
                       tmrMini.Enabled := True;
                  End;
                Spieler.AktuelleWaffe.CanShot := False;
                Spieler.AktuelleWaffe.UebrigeSchuesse := Spieler.AktuelleWaffe.UebrigeSchuesse - 1;
            End;
          End;
       End;
  End;

  main; // Hauptprozedur
  zeit := zeit + 0.1; // Zeit hochsetzen frn Sprung / Fall
  X_alt := Spieler.X;  //Fr Delta berrechnung
  Y_alt := Spieler.Y;

  If spieler.AnzLeben <= 0 then   //Wenn Spieler Tod --> Menu aufrufen
  begin
      menue := true;
      zufall:=1+random(10); //von 1 bis 9
      sndplaysound(pchar(ExtractFilePath(ParamStr(0))+'\sounds\verloren'+inttostr(zufall)+'.wav'),SND_aSync);

      form1.Timer_Menue.Enabled := true; // menue anzeigen
      sleep(250);
      form1.Timer_Run.Enabled := false;  // spiel anhalten
      end;

end;
end;


procedure TForm1.tmrGegnerTimer(Sender: TObject);
var i:integer;
begin
 for i:=0 to high(gegner) do
 begin
 gegner[i].canshot:=true;  //Gegner darf nur nach bestimmter Zeit erneut schieen
 end;
end;

procedure TForm1.chMusikClick(Sender: TObject);
begin
If chmusik.Checked = true then
mediaplayer1.Play
else
mediaplayer1.Stop;
end;

end.
